var RDFC = '@mozilla.org/rdf/container;1';
RDFC = Components.classes[RDFC].createInstance();
RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var RDFCUtils = '@mozilla.org/rdf/container-utils;1';
RDFCUtils = Components.classes[RDFCUtils].getService();
RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var RDF = '@mozilla.org/rdf/rdf-service;1'
RDF = Components.classes[RDF].getService();
RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

var gCharsetConvertManager;
gCharsetConvertManager = Components.classes['@mozilla.org/charset-converter-manager;1'].getService(Components.interfaces.nsICharsetConverterManager2);


// Search component
var gFinder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance()
                .QueryInterface(Components.interfaces.nsIFind);

//NeedleSearch preferences
var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
var nsPref = prefService.getBranch("needlesearch.");

// Is the highlight active ?
var gbHighlightOn = false;
// What was the term used for the highlighting ?
var gHighlightString = "";

// Save selection during highlighting
var gSelection = null;
var gSaveSelection = null;


var FORMDRILLER = false;
var XMLPATH = "http://www.personal-searchengines.com/rdf#"
var dsource;

var NS = new NeedleSearch()
var AA = new AutoAdder()

function NeedleSearch () {

    this.initSearchList = NeedleSearch_initSearchList
    this.DisplayCheck = NeedleSearch_DisplayCheck
    this.search = NeedleSearch_search
    this.captureEvent = NeedleSearch_captureEvent
    this.showOrHideMe = NeedleSearch_showOrHideMe
    this.ClearTerms = NeedleSearch_ClearTerms
    this.addTerm = NeedleSearch_addTerm
    this.FindInPage = NeedleSearch_FindInPage
    this.HighLightInPage = NeedleSearch_HighLightInPage
    this.changeImage = NeedleSearch_changeImage

	/**
	 *	public initContext() initializes the context menu
	 *
	 *@author Eelco van Kuik
	 */

	this.initContext = function initContext() {
		setContextItem('ShowButton')		
		setContextItem('ShowNewTabButton')
		setContextItem('ShowNewWindowButton')
		syncPref('SearchInPage')
		setContextItem('HighlightButton')
		setContextItem('AutoAddButton')
		setContextItem('EditorButton')
		setContextItem('NeedleSearchUrlButton')
	}


	/**
	 *	private setContextItem() checks or uncheckes individual context items
	 *
	 *@author Eelco van Kuik
	 */

	function setContextItem(itemID) {
		var buttonHidden = document.getElementById(itemID).getAttribute("hidden")
		document.getElementById(itemID + '-Context').setAttribute("checked", (buttonHidden != 'true'))		
	}
	
	function syncPref(itemID) {
		var prefVal
		try { 
			prefVal = nsPref.getBoolPref(itemID)
		} catch (err) {
			//Pref doesn't exist
			nsPref.setBoolPref(itemID, true)
			prefVal = nsPref.getBoolPref(itemID)
		}
		document.getElementById(itemID + '-Context').setAttribute("checked", prefVal)
	}
	
	this.changePref = function changePref(theEvent) {
		var item = theEvent.target
		nsPref.setBoolPref('SearchInPage', (item.getAttribute("checked") == "true"))		
	}


}

/**
*	Utils
*
*/

function NeedleSearch_isIn(arr, str)
{
    for(var i=0; i<arr.length; i++)
    {
        if(arr[i].toLowerCase() == NeedleSearch_TrimString(str.toLowerCase()))
            return true;
    }
    return false;
}

function NeedleSearch_TrimString(string)
{
    if (!string) return "";
    return string.replace(/(^\s+)|(\s+$)/g, '')
}


function NeedleSearch_initSearchList()
{ 
  var sources = document.getElementById('NeedleSearchMenupopup').database.GetDataSources();
  var rootnode = RDF.GetResource("urn:needlesearch:data");
  
  var i = 0
  var dsname
  while (sources.hasMoreElements()){
    i++
    try {
      dsource=sources.getNext();
      dsource=dsource.QueryInterface(Components.interfaces.nsIRDFDataSource);
      RDFC.Init(dsource,rootnode);
    } catch (e) {
      RDFCUtils.MakeSeq(dsource,rootnode);
      RDFC.Init(dsource,rootnode);
    }
    
  }
    
}


/**
 *	function HideItem(event)
 *
 *  Takes care of hiding and/or showing the buttons on the bar
 *
 *
 *  @author Eelco van Kuik
 */

function NeedleSearch_HideItem(event) {
    var item = event.target;
    var theButton;
	theButton = document.getElementById(item.getAttribute("id").replace("-Context",''));
	theButton.setAttribute("hidden",!item.getAttribute("checked"));
	
}

function NeedleSearch_DisplayCheck() {

  var main = document.getElementById("main-window");
  var needlesearch = document.getElementById("needlesearch");
  needlesearch.setAttribute("collapsed", "false");     
  if (main.hasAttribute("chromehidden") && (needlesearch != null)) {
    if (main.getAttribute("chromehidden").indexOf("location") != -1) {
      needlesearch.setAttribute("collapsed", "true");     
    }
  }
  
}

function NeedleSearch_search(target) {
	
    var method, encoding, searchstring    
    var engineList = document.getElementById('NeedleSearchMenulist')

    method = engineList.selectedItem.getAttribute("method")
    encoding = engineList.selectedItem.getAttribute("encoding")
    searchstring = engineList.selectedItem.getAttribute("searchstring")
    var searchterms = document.getElementById('NeedleSearchSearchTerms').value
	
	NeedleSearch_addSearchstring(searchterms)
	if (searchstring.length > 0) {
	//Is a searchengine selected?

		if (target == 'newtab'){
			//For a new tab
			var newTab = getBrowser().addTab('about:blank', getReferrer(document));
			getBrowser().selectedTab = newTab
			NeedleSearch_createForm(searchstring, method, encoding, "_top")
		} else {
			//For a new window and same window
			try {
				NeedleSearch_createForm(searchstring, method, encoding, target)
			} catch(er) {
				window._content.location='about:blank'
				NeedleSearch_wait("NeedleSearch_createForm('" + searchstring + "','" + method + "','" + encoding + "','" +  target + "')", target)
			}
		}

	} else {
		alert(document.getElementById('needlesearch_properties').getString('ns.no_engine_error'))
		document.getElementById('NeedleSearchMenulist').focus()
	}
    
    return false;
    
}

function NeedleSearch_wait(expression, target) {
	
	if (!window._content.document.body) {
		setTimeout('NeedleSearch_wait(' + expression + ',\'' + target + '\')', 10)	
	} else {
		eval(expression)
		if (target == '_blank') {
    		window._content.history.go(-1)
    	}
	}

}

function NeedleSearch_createForm(searchstring, method, encoding, target) {
    var theDocument = window._content.document
	
	//Older NeedleSearch users might not have this in their list   
    if (!encoding) {
    	encoding = 'UTF-8'
    }
    
    if (!method) {
    	method = 'get'
    }
	
	//Create a virtual form
    var bodyObj = theDocument.body
    var formObj = theDocument.createElement('form');
    bodyObj.appendChild(formObj)
	
    formObj.setAttribute("name", "NeedleSearch_VirtualForm")
    formObj.setAttribute("id", "NeedleSearch_VirtualForm")
	formObj.setAttribute("accept-charset", encoding)
	formObj.setAttribute("method", method)
	formObj.setAttribute("target", target)
    
   	var REurl = /&url=(.*)[?]*/;
   	var action = NeedleSearch_renderAction(searchstring)
	formObj.setAttribute("action", action)
	
	var matches = NeedleSearch_getElements(searchstring)
	var tmpInput
	for (var i=0; i < matches.length; i++) {
		tmpInput = NeedleSearch_createInput(matches[i], theDocument)
		if (tmpInput) {
			formObj.appendChild(tmpInput)
		}
	}
	theDocument.close()	
	formObj.submit()
	return false;
}

function NeedleSearch_getBodyElement(theDocument) {
	var firstChild = theDocument.childNodes.length
	var firstElement
	for (var i = 0; i < firstChild; i++) {
	firstElement = theDocument.childNodes[1].childNodes[0]
	}
	return something
}

function NeedleSearch_getElements(theUrl) {
	var formElements
	var matches = []
	if (theUrl.indexOf('?') > -1) {
		var elmnts = theUrl.substring(theUrl.indexOf('?') + 1, theUrl.length)
		matches = elmnts.split('&')
	}
	return matches		
}


function NeedleSearch_createInput(nameAndValue, theDocument) {
		var tmpVal
		var searchterms = document.getElementById('NeedleSearchSearchTerms').value
		var arrNameAndValue = nameAndValue.split('=')
		var inputObj = theDocument.createElement('input');
		inputObj.setAttribute("type", "hidden")
		var name
		if (arrNameAndValue[0] == 'submit') {
			//For some reason a formelement can't be called: submit,
			// otherwise form.submit() gives an error..!
			name = 'submit2'
		} else {
			name = arrNameAndValue[0]
		}
		
		inputObj.setAttribute("name", name)
		if (arrNameAndValue.length > 1) {
			tmpVal = arrNameAndValue[1]
			if (tmpVal == 'NeedleSearch') {
				tmpVal = searchterms
			}
			inputObj.setAttribute("value", tmpVal)
		}
		
		return inputObj
		
}

function NeedleSearch_renderAction(theUrl)	 {
		if (theUrl.indexOf('?') > -1) {
			return theUrl.substring(0,(theUrl.indexOf('?')))	
		} else {
			return theUrl
		}		
}

function NeedleSearch_addSearchstring(searchterms) {
	var NSsearchterms = document.getElementById('NeedleSearchSearchTerms')
	NSsearchterms.insertItemAt(0,searchterms,searchterms)
	try {
		NSsearchterms.removeItemAt(20)
	} catch(er) {
		//do nothing
	}
	
}

function NeedleSearch_ClearTerms() {
   var termBox = document.getElementById("NeedleSearchSearchterms");
   for(var numTerms=termBox.childNodes.length; numTerms > 0; numTerms--) {
      termBox.removeChild(termBox.childNodes[0]);
   }        
}

function NeedleSearch_addTerm(term) {

    var critBox = document.getElementById("googlebarCriteria");
	var mySearchTermBox = document.getElementById("NeedleSearchSearchterms");
	var myTerms = NeedleSearch_FindTerms(term);     
	var tempNode;
	for(var i=0;i<myTerms.length;i++) {
		tempNode = document.createElement("toolbarbutton");
		tempNode.setAttribute("label", myTerms[i]);
		tempNode.className = "NeedleSearchSearchterms";
		tempNode.setAttribute("oncommand", "NS.FindInPage('" + myTerms[i] + "')");
		tempNode.setAttribute("tooltiptext", document.getElementById('needlesearch_properties').getString('ns.searchInPage1_tt') + " \"" + myTerms[i] + "\" " + document.getElementById('needlesearch_properties').getString('ns.searchInPage2_tt'));
		tempNode.setAttribute("image", "chrome://needlesearch/content/img/term.gif");
		tempNode.setAttribute("onmouseover", "this.setAttribute('image', 'chrome://needlesearch/content/img/term_over.gif')");
		tempNode.setAttribute("onmouseout", "this.setAttribute('image', 'chrome://needlesearch/content/img/term.gif')");
		tempNode.setAttribute("orient", "horizontal");
		tempNode.setAttribute("crop", "end");
		mySearchTermBox.appendChild(tempNode);
	}
 
}

function NeedleSearch_FindInPage(str) {
	
    if (str == "") { return false }
	
	//set focus to window
	window._content.focus()
	
	var browserFinder 	= getBrowser().webBrowserFind;
	try {
		//Declare search object & set search values
		var searchObj = browserFinder.QueryInterface(Components.interfaces.nsIWebBrowserFind);
		searchObj.searchString  = str;
		searchObj.matchCase     = false;
		searchObj.wrapFind      = false;
		searchObj.findBackwards = false;

		//Loop through results
		var searchResult = searchObj.findNext();

		if(!searchResult) {
			alert(str +' ' + document.getElementById('needlesearch_properties').getString('ns.str_not_found'))
		}
	} catch(e) { 
		//catch me if you can
	}

}

function NeedleSearch_FindTerms(criteria) {
   // quotes only matter when preceded by a space or a quote.
   var terms = new Array();

   var inQuote = false;
   var haveTerm = false;

   var index = 0;       // our current pointer
   var currPtr = 0; // the start of the current term
   var prevChar = ' ';  // the char we last saw

   while (index < criteria.length) {
      var currChar = criteria.charAt(index);

      switch (currChar) {
      case ' ':
         if (!inQuote && haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
            haveTerm = false;
         }
         break;
      case '"':
         if (!inQuote) {
            if (haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
            }

        if ((prevChar == ' ') || (prevChar == '"')) {
               inQuote = true;
            }
         } else {
            if (haveTerm) {
               var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
               if (!NeedleSearch_isIn(terms, val))
                   terms.push(val);
               haveTerm = false;
               inQuote = false;
            }
         }
         break;
      default:
         if (!haveTerm) {
            haveTerm = true;
            currPtr = index;
         }
      }
      prevChar = currChar;
      index++;
   }
   var val = NeedleSearch_TrimString(criteria.substring(currPtr, index));
   if (haveTerm && !NeedleSearch_isIn(terms, val) ) {
      terms.push(val);
   }
   
   return terms;
}

function NeedleSearch_changeImage(theObj, theEvent) {
	var theImageUrl = theObj.getAttribute('image')
	var RE = /red.*[.]+png/
	if (RE.test(theImageUrl)) {
		//present image is the green image
		if (theEvent == 'over') {
			//onmouseover event
			theObj.setAttribute('image', "chrome://needlesearch/content/img/red_over.png")
		} else {
			//onmouseout event
			theObj.setAttribute('image', "chrome://needlesearch/content/img/red.png")
		}
	} 

}

/**
 * AutoAdder()
 * This class contains all functionality of the Auto-Add option
 * 
 * @author Eelco van Kuik
 */

function AutoAdder() {
	
	var NeedleSearchProgressListener = {
	  onProgressChange: function ProgressChange(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	
	  onStateChange: function StateChange(aWebProgress, aRequest, aStateFlags, aStatus) {},
	
	  onLocationChange: function LocationChange(aWebProgress, aRequest, aLocation) {
	    var domWindow = aWebProgress.DOMWindow;
	    grabURL(aLocation)
	    
	  },
	
	  onStatusChange: function StatusChange(aWebProgress, aRequest, aStatus, aMessage) {},
	
	  onSecurityChange: function SecurityChange(aWebProgress, aRequest, aState) {},
	
	  QueryInterface: function QueryInterface(aIID) {
	    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
	        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
	        aIID.equals(Components.interfaces.nsISupports))
	      return this;
	    throw Components.results.NS_NOINTERFACE;
	  }
	};
	
	
	/**
	 * public start()
	 * 
	 * This method starts the Auto-adder.
	 * 
	 * @author Eelco van Kuik
	 */
	
	this.start = function start() {
	    var total;
	    var startWin = window._content
	    
	    if (!FORMDRILLER) {
	    	changeAction(startWin)
	        FORMDRILLER = true
	        getBrowser().addProgressListener(NeedleSearchProgressListener);
	        document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/glow.png")
	        
	    } else {
	    	//switch it off
	   	    document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/red.png")
		    getBrowser().removeProgressListener(NeedleSearchProgressListener);
	    	FORMDRILLER = false
	    }
	    
	    return false
	}
	
	
	/**
	 * 
	 * private changeAction()
	 * 
	 * Changes the action to get. Adds an extra field called: "NeedleSearch_postMethod"
	 * that contains the previous method.
	 * 
	 * @author Eelco van Kuik
	 */
	
	function changeAction(theWindow) {
	    
	    var theForms
	    if (theWindow.document && theWindow.document.forms) {
	        for (var i = 0; i < theWindow.document.forms.length; ++i) {
		        
		        try {
			        //Send old method with it
		            if (theWindow.document.forms[i].method == 'post') {
		            	//It was posted
			            var inputObj = window._content.document.createElement("input")
			        	inputObj.setAttribute("name","NeedleSearch_postMethod")
			        	inputObj.setAttribute("type","hidden")
		            	theWindow.document.forms[i].appendChild(inputObj)            	
		            }
		            theWindow.document.forms[i].method="get";
				} catch(err) {
					//If this failed, let's hope the form is in another window..
				}
	
		    }
		    //Now check if there are more frames in this window
		    if (theWindow.frames) {    
		        for (var j=0; j < theWindow.frames.length; j++) {
		           changeAction(theWindow.frames[j])
		        }
		    }
		}
	}
	
	/**
	 * private grabURL()
	 * 
	 * grabs the URL of the window
	 * @author Eelco van Kuik
	 */
	
	function grabURL(aLocation) {
	    var win = window._content.document
	    var newurl = aLocation.prePath + aLocation.path
	    var method = getMethod(newurl)
	    newurl = getStrippedUrl(newurl)
	    var encoding = win.characterSet
	    
	    if (newurl.indexOf('NeedleSearch') > 0) {
	        finish(aLocation.host, newurl, method, encoding)
	    } else {
	        alert(document.getElementById('needlesearch_properties').getString('ns.autoadd_error'))
	    }
	    
	    document.getElementById('AutoAddButton').setAttribute("image", "chrome://needlesearch/content/img/red.png")
	    getBrowser().removeProgressListener(NeedleSearchProgressListener);
	    FORMDRILLER = false
	    win.close()
	}
	
	
	/**
	 * private getMethod
	 * 
	 * Gets the method from the url, depending on wether or not it contains the variable
	 * called: "NeedleSearch_postMethod"
	 * 
	 * @author Eelco van Kuik
	 */
	
	function getMethod(theSearchstring) {
		var RE = /[&|?]+NeedleSearch_postMethod=/
		var method
		if (RE.test(theSearchstring)) {
			return 'post'
		} else {
			return 'get'
		}
	}
	
	/**
	 * private getStrippedUrl()
	 * 
	 * Strips the URL of the unecessary variable: "NeedleSearch_postMethod"
	 * 
	 * @author Eelco van Kuik
	 */
	
	function getStrippedUrl(theSearchstring) {
		var win = window._content.document
		var RE = /[&|?]+NeedleSearch_postMethod=/
		return theSearchstring.replace(RE,'')
	}
	
	/**
	 * private finish()
	 * 
	 * Adds the form to the rdf file
	 * 
	 * @author Eelco van Kuik
	 */

	function finish(aHost, theNewurl, method, encoding) {   
	    var label = aHost
	    var type = 'item'
	    var insertposition = RDFC.GetCount() + 1
	    var newnode=RDF.GetAnonymousResource ();
	    var property=RDF.GetResource(XMLPATH + "label");
	    var newvalue=RDF.GetLiteral(label);
	
	    dsource.Assert(newnode,property,newvalue,true);
	
	    property=RDF.GetResource(XMLPATH + "type");
	    newvalue=RDF.GetLiteral(type);
	    dsource.Assert(newnode,property,newvalue,true);
	
	    property=RDF.GetResource(XMLPATH + "searchstring");
	    newvalue=RDF.GetLiteral(theNewurl);
	    dsource.Assert(newnode,property,newvalue,true);
	
	    property=RDF.GetResource(XMLPATH + "encoding");
	    newvalue=RDF.GetLiteral(encoding);
	    dsource.Assert(newnode,property,newvalue,true);
	
	    property=RDF.GetResource(XMLPATH + "method");
	    newvalue=RDF.GetLiteral(method);
	    dsource.Assert(newnode,property,newvalue,true);
	
	    RDFC.InsertElementAt(newnode,insertposition,true);
	    dsource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
	
	    alert(document.getElementById('needlesearch_properties').getString('ns.autoadd_succes') + label)
	    return false;
	  
	}
	
}
function NeedleSearch_captureEvent (event) {
        if (event.keyCode == 13 && event.shiftKey) {
                return NS.search('_blank')
        }

        if (event.keyCode == 13 && event.ctrlKey) {
                return NS.search('newtab')
        }

        if(event.keyCode == 13) {
                return NS.search('_top')
        }

}

function NeedleSearch_showOrHideMe(which) {
        var current_state = document.getElementById(which + '-Context').getAttribute('checked');
        if (current_state = true) {
                document.getElementById(which).hidden = true
        } else {
                document.getElementById(which).setAttribute(!document.getElementById('which').getAttribute("checked"))
        }

}

function NeedleSearch_HighLightInPage() {
    // Initialize to current document
    var gTheDocument = window._content.document;

    var termColor = new Array("yellow", "lightpink", "aquamarine", "darkgoldenrod", "darkseagreen", "lightgreen", "rosybrown", "seagreen", "chocolate", "violet");
    var critBox = document.getElementById("NeedleSearchSearchTerms");
    var term = critBox.value;

    if (gbHighlightOn)
    {
        gbHighlightOn = false;
        highlightDoc(null, null);
        if (gHighlightString == term)
            return;
    }

    gbHighlightOn = true;
    gHighlightString = term;

    var myTerms = NeedleSearch_FindTerms(term);
    for (var i = 0; i < myTerms.length; i++) {
        dump("Highlight " + myTerms[i] + "\n");

        highlightDoc(myTerms[i], termColor[i %10]);
    }
}

function highlightDoc(word, color, win)
{
    if (!win)
        win = window._content;

    for (var i=0; win.frames && i<win.frames.length; i++)
    {
        highlightDoc(word, color, win.frames[i]);
    }

    var doc = win.document;
    if(!document)
        return;

    // Remove highligthing
    if (!color)
    {
        var elem = null;
        while (elem = doc.getElementById("NeedleSearch-search-id"))
        {
            var child = null;
            var docfrag = doc.createDocumentFragment();
            var next = elem.nextSibling;
            var parent = elem.parentNode;
            while(child = elem.firstChild)
                docfrag.appendChild(child);
            parent.removeChild(elem);
            parent.insertBefore(docfrag, next);
        }
        return;
    }


    var body = doc.body;
    if (!body)
        return;
    var count = body.childNodes.length;

    searchRange = doc.createRange();
    startPt = doc.createRange();
    endPt = doc.createRange();

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + color + ";");
    baseNode.setAttribute("id", "NeedleSearch-search-id");

    searchRange.setStart(body, 0);
    searchRange.setEnd(body, count);

    startPt.setStart(body, 0);
    startPt.setEnd(body, 0);
    endPt.setStart(body, count);
    endPt.setEnd(body, count);
    highlightText(word, baseNode);

}

function highlightText(word, baseNode)
{
    var retRange = null;
    while(retRange = gFinder.Find(word, searchRange, startPt, endPt))
    {

        // check that we have a whole word
        //gSelection.addRange(range);

        // Highlight
        var nodeSurround = baseNode.cloneNode(true);
        var node = highlight(retRange, nodeSurround);
        startPt = node.ownerDocument.createRange();
        startPt.setStart(node, node.childNodes.length);
        startPt.setEnd(node, node.childNodes.length);
    }
}

function highlight(range, node)
{
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;

    var endOffset = range.endOffset;

    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
}

